'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();var _get = function get(_x, _x2, _x3) {var _again = true;_function: while (_again) {var object = _x, property = _x2, receiver = _x3;_again = false;if (object === null) object = Function.prototype;var desc = Object.getOwnPropertyDescriptor(object, property);if (desc === undefined) {var parent = Object.getPrototypeOf(object);if (parent === null) {return undefined;} else {_x = parent;_x2 = property;_x3 = receiver;_again = true;desc = parent = undefined;continue _function;}} else if ('value' in desc) {return desc.value;} else {var getter = desc.get;if (getter === undefined) {return undefined;}return getter.call(receiver);}}};function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { 'default': obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}function _inherits(subClass, superClass) {if (typeof superClass !== 'function' && superClass !== null) {throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}var _SegmentJs = require('../../Segment.js');var _SegmentJs2 = _interopRequireDefault(_SegmentJs);var _ActionNameUtilJs = require(
'../ActionNameUtil.js');var _ActionNameUtilJs2 = _interopRequireDefault(_ActionNameUtilJs);var _ThunkJs = require(
'../../Thunk.js');var _ThunkJs2 = _interopRequireDefault(_ThunkJs);

/**
 * Promise implementation, in local variable so that our code can be natural.
 *
 * @type {Function}
 */
var Promise;

/**
 * Organizes pieces inside its segment as simple key-value map. This means
 * segment piece granularity is limited to top-level values (you cannot
 * query a particular field, for instance).
 *
 * @CLIENT_SERVER
 */var 
MapSegment = (function (_Segment) {_inherits(MapSegment, _Segment);

























  /**
   * @param {Object} config
   * @param {CookieJar} cookieJar
   * @param {Object} dependencyActionCreatorMap
   * @param {Promise} PromiseImpl
   */
  function MapSegment(config, cookieJar, dependencyActionCreatorMap, PromiseImpl) {var _this = this;_classCallCheck(this, MapSegment);
    _get(Object.getPrototypeOf(MapSegment.prototype), 'constructor', this).call(this, config, cookieJar, dependencyActionCreatorMap, PromiseImpl);
    Promise = PromiseImpl;

    // Since segment name is guaranteed never to clash by ReduxStore, we can
    // safely use segment name as action type.
    var id = this.constructor.id();
    this._loadActionType = _ActionNameUtilJs2['default'].generate(id, 'LOAD');
    this._initActionType = _ActionNameUtilJs2['default'].generate(id, 'INIT');
    this._cleanActionType = _ActionNameUtilJs2['default'].generate(id, 'CLEAN');

    this._actionCreator = { 
      clean: function clean() {
        return _this._createSyncCleanAction();}, 

      load: function load(query) {
        var queryId = _this._generateQueryId(query);
        return _this._createLoadAction(query, queryId);} };}




  /**
   * Generates a unique string representing the given query. Same query must
   * generate identical strings. Query ID is used by ReduxStore and Segment
   * to recognize identical queries.
   *
   * ABSTRACT: To be overridden by child implementations.
   *
   * @param {any} query
   * @return {string}
   * @private
   */_createClass(MapSegment, [{ key: '_generateQueryId', value: 
    function _generateQueryId(query) {
      throw new Error('User must override this _generateQueryId method! Instance: ' + this + '.');}


    /**
     * Fetches query result from external source, returns a Redux thunk function
     * that may be wrapped with QueryDependencies.
     *
     * IMPORTANT NOTE: The thunk function must do the dispatch, and return a
     * Promise that resolves *after* dispatch is done.
     *
     * ABSTRACT: To be overridden by child implementations.
     *
     * @param {Thunk} thunk
     * @private
     */ }, { key: '_generateThunkFunction', value: 
    function _generateThunkFunction(thunk) {
      throw new Error('User must override _generateThunkFunction method! Instance: ' + this + '.');}


    /**
     * @param {any} piece
     * @return {string}
     */ }, { key: '_isLoaded', value: 
    function _isLoaded(piece) {
      return piece.loaded;}


    /**
     * @param {any} query
     * @param {string} queryId
     * @return {Object | Thunk}
     */ }, { key: '_createLoadAction', value: 
    function _createLoadAction(query, queryId) {
      var thunk = new _ThunkJs2['default'](this.constructor.id(), queryId, query);
      this._generateThunkFunction(thunk);
      return thunk;}


    /**
     * Creates an action object with the given state payload.
     *
     * IMPORTANT NOTE: Please make sure that you return a *new* object, as redux
     * store states are supposed to be immutable.
     *
     * @param {string} queryId
     * @param {void | any} payload
     * @param {void | Array<any>} errors
     * @return {Object}
     */ }, { key: '_createSyncLoadActionObject', value: 
    function _createSyncLoadActionObject(queryId, payload, errors) {
      return { 
        type: this._loadActionType, 
        queryId: queryId, 
        payload: { 
          data: payload, 
          updated: Date.now ? Date.now() : new Date().getTime(), 
          errors: errors, 
          loaded: errors ? false : true } };}




    /**
     * @param {string} queryId
     * @return {Object}
     */ }, { key: '_createSyncInitAction', value: 
    function _createSyncInitAction(queryId) {
      return { 
        type: this._initActionType, 
        queryId: queryId, 
        payload: { 
          data: null, 
          updated: Date.now ? Date.now() : new Date().getTime(), 
          errors: null, 
          loaded: false } };}




    /**
     * @return {Object}
     */ }, { key: '_createSyncCleanAction', value: 
    function _createSyncCleanAction() {
      return { 
        type: this._cleanActionType };}



    /**
     * @return {Object}
     */ }, { key: '_getActionCreator', value: 
    function _getActionCreator() {
      return this._actionCreator;}


    /**
     * @param {Object} state
     * @param {string} queryId
     * @return {any}
     */ }, { key: '_getPieceObject', value: 
    function _getPieceObject(state, queryId) {
      return state[queryId];}


    /**
     * @param {any} segmentStateA
     * @param {any} segmentStateB
     * @return {boolean}
     */ }, { key: '_isStateEqual', value: 
    function _isStateEqual(segmentStateA, segmentStateB) {
      // We're not using immutable because we store simple maps.
      return segmentStateA === segmentStateB;}


    /**
     * @param prevSegmentState
     * @param segmentState
     * @param queryId
     * @return {?{data: ?any; errors: ?any}}
     */ }, { key: '_comparePiece', value: 
    function _comparePiece(prevSegmentState, segmentState, queryId) {
      // If state is equal, nothing has changed, since our reducer always
      // re-creates the object.
      if (this._isStateEqual(prevSegmentState, segmentState)) {
        return null;}


      // Test the query ID, it could be that this query hasn't changed.
      if (prevSegmentState[queryId] === segmentState[queryId]) {
        return null;}


      // Otherwise, state has changed, return piece object.
      return [this._getPieceObject(segmentState, queryId)];}


    /**
     * @return {Function}
     */ }, { key: '_getReducer', value: 
    function _getReducer() {var _this2 = this;
      var loadActionType = this._loadActionType;
      var initActionType = this._initActionType;
      var cleanActionType = this._cleanActionType;
      return function (state, action) {
        // If state is undefined, return initial state.
        if (!state) state = {};
        var newState, isUninitialized;
        switch (action.type) {
          case cleanActionType:
            // Nullifies the segment:
            return {};
            break;
          case loadActionType:
            // Replace the map entry with the new loaded one.
            newState = _this2._createNewStateObj(state);
            newState[action.queryId] = action.payload;
            return newState;
            break;
          case initActionType:
            isUninitialized = !state[action.queryId] || !state[action.queryId].loaded;
            if (isUninitialized) {
              newState = _this2._createNewStateObj(state);
              newState[action.queryId] = action.payload;
              return newState;}

            break;}

        return state;};}



    /**
     * Create a new object, redux store state is supposed to immutable!
     *
     * @param {Object} state
     * @return {Object}
     */ }, { key: '_createNewStateObj', value: 
    function _createNewStateObj(state) {
      var newState = {}, queryId;
      for (queryId in state) {
        if (!state.hasOwnProperty(queryId)) continue;
        newState[queryId] = state[queryId];}

      return newState;} }]);return MapSegment;})(_SegmentJs2['default']);exports['default'] = MapSegment;module.exports = exports['default']; /**
                                                                                                                                               * @type {Object}
                                                                                                                                               */ /**
                                                                                                                                                   * @type {string}
                                                                                                                                                   */ /**
                                                                                                                                                       * @type {string}
                                                                                                                                                       */ /**
                                                                                                                                                           * @type {string}
                                                                                                                                                           */ /**
                                                                                                                                                               * @type {CookieJar}
                                                                                                                                                               */
//# sourceMappingURL=MapSegment.js.map